summaryrefslogtreecommitdiff
path: root/tests/basic
blob: 3d5097791196055e89ab8c85d69d068839ef7cbd (plain)
  1. #!/usr/bin/env bash
  2. # Tests to ensure that the monkeysphere is working
  3. # Authors:
  4. # Daniel Kahn Gillmor <dkg@fifthhorseman.net>
  5. # Jameson Rollins <jrollins@fifthhorseman.net>
  6. # Micah Anderson <micah@riseup.net>
  7. #
  8. # Copyright: 2008-2009
  9. # License: GPL v3 or later
  10. # these tests should all be able to run as a non-privileged user.
  11. # all subcommands in this script should complete without failure:
  12. set -e
  13. # piped commands should return the code of the first non-zero return
  14. set -o pipefail
  15. # make sure the TESTDIR is an absolute path, not a relative one.
  16. export TESTDIR=$(cd $(dirname "$0") && pwd)
  17. source "$TESTDIR"/common
  18. ## make sure that the right tools are installed to run the test. the
  19. ## test has *more* requirements than plain ol' monkeysphere:
  20. which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
  21. ## FIXME: other checks?
  22. ######################################################################
  23. ### FUNCTIONS
  24. # gpg command for test admin user
  25. gpgadmin() {
  26. chmod 0700 "$TEMPDIR"/admin
  27. GNUPGHOME="$TEMPDIR"/admin/.gnupg gpg "$@"
  28. }
  29. # test ssh connection
  30. # first argument is expected return code from ssh connection
  31. ssh_test() {
  32. umask 0077
  33. CODE=${1:-0}
  34. # start the ssh daemon on the socket
  35. echo "##### starting ssh server..."
  36. socat EXEC:"/usr/sbin/sshd -f ${SSHD_CONFIG} -i -D -e" "UNIX-LISTEN:${SOCKET}" 2> "$TEMPDIR"/sshd.log &
  37. SSHD_PID="$!"
  38. # wait until the socket is created before continuing
  39. while [ ! -S "$SOCKET" ] ; do
  40. sleep 1
  41. done
  42. set +e
  43. # make a client connection to the socket
  44. echo "##### starting ssh client..."
  45. ssh-agent bash -c \
  46. "monkeysphere subkey-to-ssh-agent && ssh -F $TEMPDIR/testuser/.ssh/config testhost true"
  47. RETURN="$?"
  48. # kill the sshd process if it's still running
  49. kill "$SSHD_PID"
  50. SSHD_PID=
  51. set -e
  52. echo "##### return $RETURN"
  53. if [ "$RETURN" = "$CODE" ] ; then
  54. echo "##### ssh connection test returned as desired"
  55. return 0
  56. else
  57. echo "##### ssh connection test failed. expected return code $CODE"
  58. return 1
  59. fi
  60. }
  61. SSHD_PID=
  62. ## setup trap
  63. trap failed_cleanup EXIT
  64. ######################################################################
  65. ### SETUP VARIABLES
  66. ## set up some variables to ensure that we're operating strictly in
  67. ## the tests, not system-wide:
  68. # set up temp dir
  69. # NOTE: /tmp can not be used as the temp dir here, since the
  70. # permissions on /tmp are usually such that they will not pass the
  71. # monkeysphere/ssh path permission checking. If you need to use a
  72. # different location than the current source, please set $TMPDIR
  73. # somewhere with tighter permissions.
  74. mkdir -p "$TESTDIR"/tmp
  75. TEMPDIR=$(mktemp -d "${TMPDIR:-$TESTDIR/tmp}/monkeyspheretest.XXXXXXX")
  76. # Use the local copy of executables first, instead of system ones.
  77. # This should help us test without installing.
  78. export PATH="$TESTDIR"/../src:"$TESTDIR"/../src/keytrans:"$PATH"
  79. export MONKEYSPHERE_SYSDATADIR="$TEMPDIR"
  80. export MONKEYSPHERE_SYSCONFIGDIR="$TEMPDIR"
  81. export MONKEYSPHERE_SYSSHAREDIR="$TESTDIR"/../src/share
  82. export MONKEYSPHERE_MONKEYSPHERE_USER=$(whoami)
  83. export MONKEYSPHERE_CHECK_KEYSERVER=false
  84. export MONKEYSPHERE_LOG_LEVEL=DEBUG
  85. export MONKEYSPHERE_CORE_KEYLENGTH=1024
  86. export MONKEYSPHERE_PROMPT=false
  87. export SSHD_CONFIG="$TEMPDIR"/sshd_config
  88. export SOCKET="$TEMPDIR"/ssh-socket
  89. # Make sure $DISPLAY is set to convince ssh and monkeysphere to fall
  90. # back on $SSH_ASKPASS. Make sure it's not set to the current actual
  91. # $DISPLAY (if one exists) because this test suite should not be doing
  92. # *anything* with any running X11 session.
  93. export DISPLAY=monkeys
  94. ## make sure that the version number matches the debian changelog
  95. ## (don't bother if this is being run from the tests).
  96. if [ -f "$TESTDIR"/../packaging/debian/changelog ]; then
  97. echo "##################################################"
  98. echo "### checking version string match..."
  99. repver=$(monkeysphere version)
  100. debver=$(head -n1 "$TESTDIR"/../packaging/debian/changelog | sed 's/.*(\([^-]*\)-.*/\1/')
  101. if [ "$repver" = "$debver" ] ; then
  102. echo "Versions match!"
  103. else
  104. printf "reported version string (%s) does not match debian changelog (%s)\n" "$repver" "$debver"
  105. exit 1
  106. fi
  107. fi
  108. ######################################################################
  109. ### CONFIGURE ENVIRONMENTS
  110. # copy in admin and testuser home to tmp
  111. echo "##################################################"
  112. echo "### configuring testuser home..."
  113. cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
  114. # set up environment for testuser
  115. export TESTHOME="$TEMPDIR"/testuser
  116. export GNUPGHOME="$TESTHOME"/.gnupg
  117. chmod 0700 "$GNUPGHOME"
  118. export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
  119. export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
  120. cat <<EOF >> "$TESTHOME"/.ssh/config
  121. UserKnownHostsFile $TESTHOME/.ssh/known_hosts
  122. IdentityFile $TESTHOME/.ssh/no-such-identity
  123. ProxyCommand $TESTHOME/.ssh/proxy-command %h %p $SOCKET
  124. EOF
  125. cat <<EOF >> "$MONKEYSPHERE_HOME"/monkeysphere.conf
  126. KNOWN_HOSTS=$TESTHOME/.ssh/known_hosts
  127. EOF
  128. get_gpg_prng_arg >> "$GNUPGHOME"/gpg.conf
  129. echo "##################################################"
  130. echo "### configuring admin home..."
  131. cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
  132. # set up sshd
  133. echo "##################################################"
  134. echo "### configuring sshd..."
  135. cp "$TESTDIR"/etc/ssh/sshd_config "$SSHD_CONFIG"
  136. # write the sshd_config
  137. cat <<EOF >> "$SSHD_CONFIG"
  138. HostKey ${MONKEYSPHERE_SYSDATADIR}/ssh_host_rsa_key
  139. AuthorizedKeysFile ${MONKEYSPHERE_SYSDATADIR}/authorized_keys/%u
  140. EOF
  141. ######################################################################
  142. ### SERVER HOST SETUP
  143. # import host key
  144. echo "##################################################"
  145. echo "### import host key..."
  146. ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
  147. monkeysphere-host import-key "$TEMPDIR"/ssh_host_rsa_key testhost
  148. echo "##################################################"
  149. echo "### getting host key fingerprint..."
  150. HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\ )
  151. echo "$HOSTKEYID"
  152. # change host key expiration
  153. echo "##################################################"
  154. echo "### setting host key expiration..."
  155. monkeysphere-host set-expire 1
  156. # FIXME: how do we check that the expiration has really been set?
  157. # certify host key with the "Admin's Key".
  158. # (this would normally be done via keyservers)
  159. echo "##################################################"
  160. echo "### certifying server host key..."
  161. GNUPGHOME="$MONKEYSPHERE_SYSCONFIGDIR"/host gpg --armor --export "$HOSTKEYID" | gpgadmin --import
  162. echo y | gpgadmin --command-fd 0 --sign-key "$HOSTKEYID"
  163. # FIXME: add revoker?
  164. # FIXME: how can we test publish-key without flooding junk into the
  165. # keyservers?
  166. # FIXME: should we run "diagnostics" here to test setup?
  167. ######################################################################
  168. ### SERVER AUTHENTICATION SETUP
  169. # set up monkeysphere authentication
  170. echo "##################################################"
  171. echo "### setup monkeysphere authentication..."
  172. cp "$TESTDIR"/etc/monkeysphere/monkeysphere-authentication.conf "$TEMPDIR"/
  173. cat <<EOF >> "$TEMPDIR"/monkeysphere-authentication.conf
  174. AUTHORIZED_USER_IDS="$MONKEYSPHERE_HOME/authorized_user_ids"
  175. EOF
  176. monkeysphere-authentication setup
  177. get_gpg_prng_arg >> "$MONKEYSPHERE_SYSDATADIR"/authentication/sphere/gpg.conf
  178. # add admin as identity certifier for testhost
  179. echo "##################################################"
  180. echo "### adding admin as certifier..."
  181. monkeysphere-authentication add-id-certifier "$TEMPDIR"/admin/.gnupg/pubkey.gpg
  182. echo "##################################################"
  183. echo "### list certifiers..."
  184. monkeysphere-authentication list-certifiers
  185. # FIXME: should we run "diagnostics" here to test setup?
  186. ######################################################################
  187. ### TESTUSER SETUP
  188. # generate an auth subkey for the test user that expires in 2 days
  189. echo "##################################################"
  190. echo "### generating key for testuser..."
  191. monkeysphere gen-subkey
  192. # add server key to testuser keychain
  193. echo "##################################################"
  194. echo "### export server key to testuser..."
  195. gpgadmin --armor --export "$HOSTKEYID" | gpg --import
  196. # teach the "server" about the testuser's key
  197. echo "##################################################"
  198. echo "### export testuser key to server..."
  199. gpg --export testuser | monkeysphere-authentication gpg-cmd --import
  200. # update authorized_keys for user
  201. echo "##################################################"
  202. echo "### update server authorized_keys file for this testuser..."
  203. monkeysphere-authentication update-users $(whoami)
  204. # FIXME: this is maybe not failing properly for:
  205. # ms: improper group or other writability on path '/tmp'.
  206. ######################################################################
  207. ### TESTS
  208. # connect to test sshd, using monkeysphere ssh-proxycommand to verify
  209. # the identity before connection. This should work in both directions!
  210. echo "##################################################"
  211. echo "### ssh connection test for success..."
  212. ssh_test
  213. # remove the testuser's authorized_user_ids file, update, and make
  214. # sure that the ssh authentication FAILS
  215. echo "##################################################"
  216. echo "### removing testuser authorized_user_ids and updating..."
  217. mv "$TESTHOME"/.monkeysphere/authorized_user_ids{,.bak}
  218. monkeysphere-authentication update-users $(whoami)
  219. echo "##################################################"
  220. echo "### ssh connection test for server authentication denial..."
  221. ssh_test 255
  222. mv "$TESTHOME"/.monkeysphere/authorized_user_ids{.bak,}
  223. # put improper permissions on authorized_user_ids file, update, and
  224. # make sure ssh authentication FAILS
  225. echo "##################################################"
  226. echo "### setting group writability on authorized_user_ids and updating..."
  227. chmod g+w "$TESTHOME"/.monkeysphere/authorized_user_ids
  228. monkeysphere-authentication update-users $(whoami)
  229. echo "##################################################"
  230. echo "### ssh connection test for server authentication denial..."
  231. ssh_test 255
  232. chmod g-w "$TESTHOME"/.monkeysphere/authorized_user_ids
  233. echo "##################################################"
  234. echo "### setting other writability on authorized_user_ids and updating..."
  235. chmod o+w "$TESTHOME"/.monkeysphere/authorized_user_ids
  236. monkeysphere-authentication update-users $(whoami)
  237. echo "##################################################"
  238. echo "### ssh connection test for server authentication denial..."
  239. ssh_test 255
  240. chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
  241. # FIXME: addtest: remove admin as id-certifier and check ssh failure
  242. # FIXME: addtest: add hostname on host key
  243. # FIXME: addtest: revoke hostname on host key and check ssh failure
  244. # FIXME: addtest: revoke the host key and check ssh failure
  245. ######################################################################
  246. trap - EXIT
  247. echo "##################################################"
  248. echo " Monkeysphere basic tests completed successfully!"
  249. echo "##################################################"
  250. cleanup